import 'dart:math';

import 'package:contentsquare_platform_interface/contentsquare_platform_interface.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

import 'gesture_listener.dart';


class a132 extends StatelessWidget {
  
  final Widget a83;

  
  final Function(Offset position)? a82;

  
  final Function(Offset position)? a81;

  
  final Function(Offset position, ContentsquareGestureData data)? a80;

  
  final Function(Offset position, ContentsquareGestureData data)? a79;

  
  const a132({
    Key? a480,
    required this.a83,
    this.a82,
    this.a81,
    this.a80,
    this.a79,
  }) : super(key: a480);

  bool _a208(a126 a481) {
    return a481.a107.distance.isFinite && a481.a106.isFinite;
  }

  void _a209(PointerEvent a482) {
    a82?.call(a482.position);
  }

  void _a210(PointerEvent a483) {
    a81?.call(a483.position);
  }

  void _a211(a126 a484) {
    final a307 = _a212(a484.a107);
    if (a307 == null) return;

    if (!_a208(a484)) return;

    final ContentsquareGestureData a308 = ContentsquareGestureData(
        distance: a484.a107.distance.toInt(),
        direction: a307,
        velocity:
            max(a484.a106.dx.abs(), a484.a106.dy.abs()).toInt());

    if (a308.velocity >= kMinFlingVelocity) {
      a79?.call(a484.a108, a308);
    } else {
      a80?.call(a484.a108, a308);
    }
  }

  static ContentsquareGestureDirection? _a212(Offset a485) {
    if (a485.dx == 0 && a485.dy == 0) return null;

    if (a485.dx.abs() <= a485.dy.abs()) {
      /// Vertical Gesture
      /// gestureDirection = CSGestureDirection.down OR CSGestureDirection.up
      return a485.dy > 0
          ? ContentsquareGestureDirection.down
          : ContentsquareGestureDirection.up;
    }

    /// Horizontal Gesture
    /// gestureDirection = CSGestureDirection.right OR CSGestureDirection.left
    return a485.dx > 0
        ? ContentsquareGestureDirection.right
        : ContentsquareGestureDirection.left;
  }

  @override
  Widget build(BuildContext context) {
    return a127(
      a104: _a209,
      a103: _a210,
      a99: _a211,
      a105: a83,
    );
  }
}
