import 'package:contentsquare/contentsquare.dart';
import 'package:contentsquare_example/src/widgets/app_bar.dart';
import 'package:flutter/material.dart';
import 'package:webview_flutter/webview_flutter.dart';

class FullyTrackedFlutterWebViewScreen extends StatelessWidget {
  const FullyTrackedFlutterWebViewScreen({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: appBar(title: 'Tracked (webview_flutter)'),
      body: ContentsquareWebViewTrackerBuilder(
        builder: (context, tracker) {
          return WebView(
            initialUrl:
                'https://tupeuxpastest.csq.io/mobile/web-view-cart.html',
            javascriptMode: JavascriptMode.unrestricted,
            onWebViewCreated: tracker.onWebViewCreated,
            onPageFinished: tracker.onPageFinished,
            javascriptChannels: tracker.javascriptChannels,
          );
        },
      ),
    );
  }
}
