import 'dart:collection';

import 'package:flutter/rendering.dart';
import 'package:flutter/widgets.dart';

import '../../logger/logger.dart';
import '../widgets_binding.dart';
import '../../webview_tracking/webview_tracking.dart';
import '../compression.dart';
import '../element_extension.dart';
import '../unmodifiable_list_view_extension.dart';
import 'get_element_data_of_hit_render_object.dart';
import 'hit_element_data.dart';
import 'results/hit_leaves_element_tvps_result.dart';
import 'results/hit_maybe_result.dart';

part 'get_leaves_element_tvps.dart';


UnmodifiableListView<String> a257(Offset a528) {
  final a378 = _a259(a528);

  final a379 = a267(
    a535: a378,
    a536: a140.a232(a500: a528),
  );

  a258() => UnmodifiableListView<String>([]);

  return a379.a13(
    a427: () {
      
      
      
      
      
      a187.a39(
        a151(
          a529: a528,
          a530: a378,
        ),
      );
      return a258();
    },
    a428: (hitElementData) {
      final a380 = hitElementData.a69.a85;
      if (a380.a225) {
        
        
        return a258();
      }

      final a381 = _a250(
        a524: hitElementData,
      );

      return a381.a9(
        
        a416: () => a258(),
        a417: (leavesScreengraphTVPs) {
          
          
          final a382 =
              leavesScreengraphTVPs.a249();

          final a383 =
              a382.map(a193).toList();

          return UnmodifiableListView(a383);
        },
      );
    },
  );
}


@visibleForTesting
class a151 extends a122 {
  
  a151({
    required Offset a529,
    required RenderObject a530,
  }) : super(
          'Could not find the element associated with the RenderObject $a530 that was found for the gesture at $a529',
        );
}


RenderObject _a259(Offset a531) {
  final a384 = a180.a207!.renderView;

  
  
  final a385 = BoxHitTestResult();
  a384.hitTest(a385, position: a531);

  
  return a385.path
      .firstWhere((element) => element.target is RenderObject)
      .target as RenderObject;
}