import 'package:contentsquare/src/modules/logger/logger.dart';

import 'webview_log.dart';


class a156 extends a124 with a134 {
  
  a156({
    required String? a532,
    required String a533,
  }) : super(
          '''
WebView tracking initialization failed${a532 == null ? '' : ' on WebView with initialUrl: $a532'}.

Reason: $a533
          
                
The expected [ContentsquareWebViewTrackerBuilder] usage is:
```dart
ContentsquareWebViewTrackerBuilder(
  builder: (context, tracker) => WebView(
    onPageFinished: tracker.onPageFinished,
    onWebViewCreated: tracker.onWebViewCreated,
    javascriptChannels: tracker.javascriptChannels,
    javascriptMode: JavascriptMode.unrestricted,
    initialUrl: 'https://tupeuxpastest.csq.io/mobile/web-view-cart.html',
  ),
)
          ''',
        );
}
